package de.fhws.robotxkey.txc;

import java.io.InputStream;
import java.io.OutputStream;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;

public class TxcConnection {
	public boolean boolValid = false;
	
	public BluetoothSocket bluetoothsocketHandle = null;
	public InputStream inputstreamHandle = null;
	public OutputStream outputstreamHandle = null;
	
	public TxcConnection() {
		{
			this.boolValid = false;
		}
		
		{
			this.bluetoothsocketHandle = null;
			this.inputstreamHandle = null;
			this.outputstreamHandle = null;
		}
	}
	
	public void finalize() {
		{
			this.boolValid = false;
		}
		
		{
			this.bluetoothsocketHandle = null;
			this.inputstreamHandle = null;
			this.outputstreamHandle = null;
		}
	}
	
	public void connect(String strMac) {
		{
			this.boolValid = false;
		}
		
		{
			this.bluetoothsocketHandle = null;
			this.inputstreamHandle = null;
			this.outputstreamHandle = null;
		}
		
		try {
			{
				this.boolValid = false;
			}
			
			{
				BluetoothDevice bluetoothdeviceHandle = BluetoothAdapter.getDefaultAdapter().getRemoteDevice(strMac);
				
				this.bluetoothsocketHandle = (BluetoothSocket) (bluetoothdeviceHandle.getClass().getMethod("createRfcommSocket", new Class[] { int.class }).invoke(bluetoothdeviceHandle, Integer.valueOf(1)));
				
				this.inputstreamHandle = this.bluetoothsocketHandle.getInputStream();
				this.outputstreamHandle = this.bluetoothsocketHandle.getOutputStream();
				
				this.bluetoothsocketHandle.connect();
			}
			
			{
				this.boolValid = true;
			}
		} catch (Exception e) {
			// e.printStackTrace();
		}
	}
	
	public void disconnect() {
		try {
			{
				this.bluetoothsocketHandle.close();
			}
		} catch (Exception e) {
			// e.printStackTrace();
		}
		
		{
			this.boolValid = false;
		}
		
		{
			this.bluetoothsocketHandle = null;
			this.inputstreamHandle = null;
			this.outputstreamHandle = null;
		}
	}
}
